#include <iostream>
#include "AneuMeshLoader.h"
using namespace std;


//!!! Задание на защиту (не удалять!)
//!!! Реализовать на основе std::ranges
//!!! 1. Создать контейнер тетраэдральных КЭ из данной области.
//!!! 2. С помощью потокового итератора вывести в файл списки ID узлов тех тетраэдров,
//!!!    у которых минимальный двугранный угол от 0 до 30 градусов. 


//!!! Это куда-то в Data_types.h
std::ostream& operator << (std::ostream& out, const std::vector <Node>& elem);
std::ostream& operator << (std::ostream& out, const std::vector <FiniteElement>& elem);
std::ostream& operator << (std::ostream& out, const std::vector <BoundaryFiniteElement>& elem);
std::ostream& operator << (std::ostream& out, const std::vector <vector<Node>>& elem);

int main() {
	MeshLoader* MyKE = new AneuMeshLoader; //!!! Утечка памяти
	
	
	std::string str;
	cout << "Enter the file name:";
	cin >> str;
	MyKE->loadMesh(str);

	cout << "---------------STL-container nodes---------------"<<endl;
	cout << MyKE->vector_Node() <<endl;

	cout << "---------------STL-container finite elements---------------"<<endl;
	cout << MyKE->vector_FiniteElement()<<endl;

	cout << "---------------STL-container boundary finite elements---------------"<<endl;
	cout << MyKE->vector_BoundaryFiniteElement() <<endl;

	cout << "---------------Finite element by three nodes---------------" << endl;
	cout << "Enter three nodes:";
	int id1, id2, id3;
	cin >> id1 >> id2 >> id3;
	cout << MyKE->FiniteElementByThreeNodes(id1,id2,id3) << endl;

	cout << "---------------Finite element by two nodes---------------" << endl;
	cout << "Enter two nodes:";
	cin >> id1 >> id2;
	cout << MyKE->FiniteElementByTwoNodes(id1, id2) << endl;

	cout << "---------------Container of boundary nodes by border ID---------------" << endl;
	cout << "Enter border ID:";
	cin >> id1;
	cout << MyKE->BoundaryNodes(id1) << endl;

	cout << "---------------Container KE by border ID---------------" << endl;
	cout << "Enter border ID:";
	cin >> id1;
	cout << MyKE->KE(id1) << endl;

	cout << "---------------Container boundary KE by border ID---------------" << endl;
	cout << "Enter border ID:";
	cin >> id1;
	cout << MyKE->BoundaryKE(id1) << endl;

	cout << "---------------Container with containers of \"neighboring\" nodes---------------" << endl;
	cout << MyKE->ContainerOfNodeContainers() << endl;
	
	cout << "---------------Print Node---------------" << endl;
	MyKE->print_Node();

	cout << "---------------Print FiniteElement---------------" << endl;
	MyKE->print_FiniteElement();

	cout << "---------------Print BoundaryFiniteElement---------------" << endl;
	MyKE->print_BoundaryFiniteElement();

	cout << "---------------Inserting new nodes in the middle of the edges of the KE---------------" << endl;
	MyKE->NewNodes();
	cout << "STL-container nodes:" << endl;
	cout << MyKE->vector_Node() << endl;
	cout << "STL-container finite elements:" << endl;
	cout << MyKE->vector_FiniteElement() << endl;
	cout << "STL-container boundary finite elements:" << endl;
	cout << MyKE->vector_BoundaryFiniteElement() << endl;

	return 0;
}