#pragma once
#include "Data_types.h"

class MeshLoader {
protected:
	std::vector<Node> p_Node;
	std::vector<FiniteElement> p_FiniteElement;
	std::vector<BoundaryFiniteElement> p_BoundaryFiniteElement;

public:
	virtual void loadMesh(const std::string&)=0;
	
	~MeshLoader() = default; //!!! Почему деструктор не виртуальный?

	//,   STL- ,     
	std::vector<Node> vector_Node();
	std::vector<FiniteElement> vector_FiniteElement();
	std::vector<BoundaryFiniteElement> vector_BoundaryFiniteElement();

	//,     ID      
	std::vector<FiniteElement>FiniteElementByThreeNodes(int, int, int);
	std::vector<FiniteElement> FiniteElementByTwoNodes(int id1, int id2);

	//,    ,      id 
	std::vector<Node> BoundaryNodes(int id);
	std::vector<FiniteElement> KE(int id);
	std::vector<BoundaryFiniteElement> BoundaryKE(int id);

	//,   
	void NewNodes();

	//  "" 
	std::vector<std::vector<Node>> ContainerOfNodeContainers();

	// 
	void print_Node();
	void print_FiniteElement();
	void print_BoundaryFiniteElement();

	// 
	friend std::ostream& operator << (std::ostream& out, const std::vector <Node>& elem);
	friend std::ostream& operator << (std::ostream& out, const std::vector <FiniteElement>& elem);
	friend std::ostream& operator << (std::ostream& out, const std::vector <BoundaryFiniteElement>& elem);
	friend std::ostream& operator << (std::ostream& out, const std::vector <std::vector<Node>>& elem);
};

